<!--
  This page allows to easily print the beneficiary details in a valid design.
  It improves cross-browser compatibility that is not easily reachable with print media queries.
-->

<template>
  <div>
    <NuxtLink
      :to="backLink"
      class="fr-link fr-icon-arrow-left-line fr-link--icon-left no-print"
      target="_self"
    >
      Retour
    </NuxtLink>

    <AtomAlert
      v-if="error"
      :alert-type="AlertType.Error"
      message="Les informations du bénéficiaire n'ont pas pu être chargées."
    />
    <AtomLoader
      v-else-if="pending"
      class="fr-mx-auto"
    />
    <template v-else-if="beneficiary">
      <h1>{{ beneficiaryName(beneficiary) }}</h1>
      <section class="beneficiary-details-section">
        <h2 class="fr-h6">Bénéficiaire</h2>
        <ul class="information-list">
          <li>
            <span class="information-label">N° dossier :</span>
            {{ readableFileNumber(beneficiary.id) }}
          </li>
          <li>
            <span class="information-label">Agent(s) référent(s) :</span>
            {{ referents }}
          </li>
          <li v-if="beneficiary.aidant_connect_authorisation">
            ✅ Mandat Aidant Connect
          </li>
          <li v-if="beneficiary.title">
            <span class="information-label">Civilité :</span>
            {{ TITLE_OPTIONS.get(beneficiary.title) }}
          </li>
          <li>
            <span class="information-label">Nom usuel :</span>
            {{ usualName }}
          </li>
          <li v-if="beneficiary.birth_name">
            <span class="information-label">Nom de naissance :</span>
            {{ beneficiary.birth_name }}
          </li>
          <li>
            <span class="information-label">Prénom(s) :</span>
            {{ nameOrEmpty(beneficiary.firstname) }}
          </li>
          <li v-if="beneficiary.birthdate">
            <span class="information-label">Date de naissance :</span>
            {{ formatDate(beneficiary.birthdate) }} ({{
              age(beneficiary.birthdate)
            }}
            ans)
          </li>
          <li v-if="beneficiary.birth_place">
            <span class="information-label">Ville de naissance :</span>
            {{ beneficiary.birth_place }}
          </li>
          <li v-if="beneficiary.deathdate">
            <span class="information-label">Date de décès :</span>
            {{ formatDate(beneficiary.deathdate) }}
          </li>
          <li v-if="beneficiary.gender">
            <span class="information-label">Genre :</span>
            {{ GENDER_OPTIONS.get(beneficiary.gender) }}
          </li>
          <li v-if="beneficiary.nationality">
            <span class="information-label">Nationalité :</span>
            {{ NATIONALITY_OPTIONS.get(beneficiary.nationality) }}
          </li>
          <li v-if="isMinistryAgent && beneficiary.numero_pegase">
            <span class="information-label">Numéro Pégase :</span>
            {{ beneficiary.numero_pegase }}
          </li>

          <li v-if="beneficiary.accommodation_mode">
            <span
              :class="{ 'information-line': beneficiary.accommodation_name }"
            >
              <span class="information-label">Hébergement :</span>
              {{
                ACCOMMODATION_MODE_OPTIONS.get(beneficiary.accommodation_mode)
              }}
            </span>
            <span
              v-if="beneficiary.accommodation_name"
              class="information-line"
            >
              {{ beneficiary.accommodation_name }}
            </span>
          </li>
          <li v-if="beneficiary.accommodation_additional_information">
            <span class="information-label">Précisions hébergement :</span>
            {{ beneficiary.accommodation_additional_information }}
          </li>
          <li v-if="hasAddress">
            <span class="information-label information-line">Adresse :</span>
            <span
              v-if="beneficiary.street"
              class="information-line"
            >
              {{ beneficiary.street_number }} {{ beneficiary.street }}
            </span>
            <span
              v-if="beneficiary.address_complement"
              class="information-line"
            >
              {{ beneficiary.address_complement }}
            </span>
            <span
              v-if="beneficiary.zip_code || beneficiary.city"
              class="information-line"
            >
              {{ beneficiary.zip_code }} {{ beneficiary.city }}
            </span>
          </li>
          <li v-if="beneficiary.no_phone">❌ N'a pas de téléphone</li>
          <li v-if="!beneficiary.no_phone && beneficiary.phone_1">
            <span class="information-label">Téléphone :</span> {{ phone }}
          </li>
          <li v-if="beneficiary.email">
            <span class="information-label">Email :</span>
            {{ beneficiary.email }}
          </li>
          <li v-if="beneficiary.family_situation">
            <span class="information-label">Situation familiale :</span>
            {{ FAMILY_SITUATION_OPTIONS.get(beneficiary.family_situation) }}
          </li>
          <li v-if="beneficiary.caregiver">✅ Aidant familial</li>
          <li v-if="beneficiary.minor_children">
            {{ beneficiary.minor_children }}
            <span class="information-label">{{ minorChildrenLabel }}</span>
          </li>
          <li v-if="beneficiary.major_children">
            {{ beneficiary.major_children }}
            <span class="information-label">{{ majorChildrenLabel }}</span>
          </li>
          <li v-if="beneficiary.mobility">
            <span class="information-label">Données mobilité :</span>
            {{ MOBILITY_MODE_OPTIONS.get(beneficiary.mobility) }}
          </li>
          <li v-if="beneficiary.administration">
            <span class="information-label">Administration :</span>
            {{ beneficiary.administration }}
          </li>
          <li v-if="beneficiary.minister">
            <span class="information-label">Ministre :</span>
            {{ beneficiary.minister }}
          </li>
        </ul>
      </section>
      <section
        v-if="hasHealthSection"
        class="beneficiary-details-section"
      >
        <h2 class="fr-h6">Santé</h2>
        <ul class="information-list">
          <li v-if="beneficiary.gir">
            <span class="information-label">GIR :</span>
            {{ girLabel(beneficiary.gir) }}
          </li>
          <li v-if="beneficiary.doctor">
            <span class="information-label">Médecin traitant :</span>
            {{ beneficiary.doctor }}
          </li>
          <li v-if="beneficiary.health_additional_information">
            <span class="information-label"
              >Informations complémentaires :</span
            >
            {{ beneficiary.health_additional_information }}
          </li>
          <li v-if="hasNirAccess && beneficiary.social_security_number">
            <span class="information-label">N° Sécurité Sociale :</span>
            {{ beneficiary.social_security_number }}
          </li>
          <li v-if="beneficiary.insurance">
            <span class="information-label">Mutuelle :</span>
            {{ beneficiary.insurance }}
          </li>
        </ul>
      </section>
      <section
        v-if="hasOccupationIncomeSection"
        class="beneficiary-details-section"
      >
        <h2 class="fr-h6">Activité/Revenu</h2>
        <ul class="information-list">
          <li v-if="beneficiary.socio_professional_category">
            <span class="information-label"
              >Catégorie socio-professionnelle :</span
            >
            {{
              SOCIO_PROFESSIONAL_CATEGORY_OPTIONS.get(
                beneficiary.socio_professional_category
              )
            }}
          </li>
          <li v-if="beneficiary.occupation">
            <span class="information-label">Profession(s) :</span>
            {{ beneficiary.occupation }}
          </li>
          <li v-if="beneficiary.employer">
            <span class="information-label">Employeur :</span>
            {{ beneficiary.employer }}
          </li>
          <li v-if="beneficiary.employer_siret">
            <span class="information-label">SIRET de l'employeur :</span>
            {{ beneficiary.employer_siret }}
          </li>
          <li v-if="mainIncomeType">
            <span class="information-label">Nature des ressources :</span>
            {{ mainIncomeType }}
          </li>
          <li v-if="beneficiary.main_income_amount">
            <span class="information-label">Montant des ressources :</span>
            {{ euros(beneficiary.main_income_amount) }}
          </li>
          <li v-if="partnerMainIncomeType">
            <span class="information-label"
              >Nature des ressources du conjoint :</span
            >
            {{ partnerMainIncomeType }}
          </li>
          <li v-if="beneficiary.partner_main_income_amount">
            <span class="information-label"
              >Montant des ressources du conjoint :</span
            >
            {{ euros(beneficiary.partner_main_income_amount) }}
          </li>
          <li v-if="majorChildrenMainIncomeType">
            <span class="information-label"
              >Nature des ressources des enfants majeurs :</span
            >
            {{ majorChildrenMainIncomeType }}
          </li>
          <li v-if="beneficiary.major_children_main_income_amount">
            <span class="information-label"
              >Montant des ressources des enfants majeurs :</span
            >
            {{ euros(beneficiary.major_children_main_income_amount) }}
          </li>
          <li v-if="beneficiary.pole_emploi">
            <span class="information-label">N° Pôle Emploi :</span>
            {{ beneficiary.pole_emploi }}
          </li>
          <li v-if="pensionOrganisations">
            <span class="information-label">Organisme(s) de retraite :</span>
            {{ pensionOrganisations }}
          </li>
          <li v-if="beneficiary.caf">
            <span class="information-label">N° CAF :</span>
            {{ beneficiary.caf }}
          </li>
          <li v-if="beneficiary.bank">
            <span class="information-label">Banque :</span>
            {{ beneficiary.bank }}
          </li>
          <li v-if="beneficiary.funeral_contract">
            <span class="information-label">Contrat obsèques :</span>
            {{ beneficiary.funeral_contract }}
          </li>
          <template v-if="isMinistryAgent">
            <li v-if="beneficiary.ministere_categorie">
              <span class="information-label">Catégorie :</span>
              {{
                MINISTERE_CATEGORIE_OPTIONS.get(beneficiary.ministere_categorie)
              }}
            </li>
            <li v-if="beneficiary.ministere_departement_service_ac">
              <span class="information-label"
                >Département ou service de l'Administration Centrale :</span
              >
              {{
                MINISTERE_DEPARTEMENT_SERVICE_AC_OPTIONS.get(
                  beneficiary.ministere_departement_service_ac
                )
              }}
            </li>
            <li v-if="beneficiary.ministere_structure">
              <span class="information-label">Structure de rattachement :</span>
              {{
                MINISTERE_STRUCTURE_OPTIONS.get(beneficiary.ministere_structure)
              }}
            </li>
          </template>
        </ul>
      </section>
      <section
        v-if="beneficiary.relatives.length"
        class="beneficiary-details-section"
      >
        <h2 class="fr-h6">Entourage</h2>
        <ul class="information-list">
          <li
            v-for="relative in beneficiary.relatives"
            :key="relative.id"
          >
            <span class="information-line">
              {{ relativeGeneralInformation(relative) }}
            </span>
            <span
              v-if="relative.city || relative.phone || relative.email"
              class="information-line"
            >
              {{ relativeContact(relative) }}
            </span>
            <span
              v-if="relative.hosted"
              class="information-line"
            >
              ✅ Vit au domicile du bénéficiaire
            </span>
            <span
              v-if="relative.caregiver"
              class="information-line"
            >
              ✅ Aidant familial
            </span>
            <span
              v-if="relative.additional_information"
              class="information-line"
            >
              {{ relative.additional_information }}
            </span>
          </li>
        </ul>
      </section>
      <section class="beneficiary-details-section">
        <h2 class="fr-h6">Types d'accompagnement</h2>
        <section class="fr-mb-1w">
          <h3 class="fr-text--lg fr-mb-0">Aides légales</h3>
          <ul
            v-if="legalFollowUpTypes.length"
            class="fr-mt-1v"
          >
            <li
              v-for="followUpType in legalFollowUpTypes"
              :key="followUpType.id"
            >
              {{ followUpType.name }}
            </li>
          </ul>
          <span
            v-else
            class="information-line"
          >
            Aucune
          </span>
        </section>
        <section>
          <h3 class="fr-text--lg fr-mb-0">Aides facultatives</h3>
          <ul
            v-if="optionalFollowUpTypes.length"
            class="fr-mt-1v"
          >
            <li
              v-for="followUpType in optionalFollowUpTypes"
              :key="followUpType.id"
            >
              {{ followUpType.name }}
            </li>
          </ul>
          <span
            v-else
            class="information-line"
          >
            Aucune
          </span>
        </section>
      </section>
      <section
        v-if="hasOtherInformationSection"
        class="beneficiary-details-section"
      >
        <h2 class="fr-h6">Autres informations</h2>
        <ul class="information-list">
          <li v-if="beneficiary.protection_measure">
            <span class="information-label">Mesure de protection :</span>
            {{ PROTECTION_MEASURE_OPTIONS.get(beneficiary.protection_measure) }}
          </li>
          <li v-if="beneficiary.representative">
            <span class="information-label information-line">
              Nom, prénom, coordonées du mandataire :
            </span>
            <span class="information-line">
              {{ beneficiary.representative }}
            </span>
          </li>
          <li v-if="beneficiary.prescribing_organisation">
            <span class="information-label">Organisme prescripteur :</span>
            {{ beneficiary.prescribing_organisation }}
          </li>
          <li v-if="beneficiary.orientation_type">
            <span class="information-label">Mode d'orientation :</span>
            {{ ORIENTATION_TYPE_OPTIONS.get(beneficiary.orientation_type) }}
          </li>
          <li v-if="beneficiary.orientation_organisation">
            <span class="information-label">Organisme d'orientation :</span>
            {{ beneficiary.orientation_organisation }}
          </li>
          <li v-if="beneficiary.service_providers">
            <span class="information-label">Prestataires :</span>
            {{ beneficiary.service_providers }}
          </li>
          <li v-if="beneficiary.involved_partners">
            <span class="information-label">Partenaires intervenants :</span>
            {{ beneficiary.involved_partners }}
          </li>
          <li v-if="beneficiary.additional_information">
            <span class="information-label">
              Informations complémentaires :
            </span>
            {{ beneficiary.additional_information }}
          </li>
        </ul>
      </section>
    </template>
  </div>
</template>

<script setup>
  import { AlertType } from '~/utils/constants/alert'
  import {
    age,
    agentName,
    euros,
    formatDate,
    readableFileNumber,
    relativeContact,
    relativeGeneralInformation,
    girLabel
  } from '~/utils'
  import {
    ACCOMMODATION_MODE_OPTIONS,
    FAMILY_SITUATION_OPTIONS,
    GENDER_OPTIONS,
    MINISTERE_CATEGORIE_OPTIONS,
    MINISTERE_DEPARTEMENT_SERVICE_AC_OPTIONS,
    MINISTERE_STRUCTURE_OPTIONS,
    MOBILITY_MODE_OPTIONS,
    SOCIO_PROFESSIONAL_CATEGORY_OPTIONS,
    TITLE_OPTIONS,
    PROTECTION_MEASURE_OPTIONS,
    ORIENTATION_TYPE_OPTIONS
  } from '~~/utils/constants/beneficiary'
  import { NATIONALITY_OPTIONS } from '~~/utils/constants/nationalities'
  import { getRandomId } from '~/utils/random'
  import { beneficiaryName, nameOrEmpty } from '~/utils/beneficiary'
  import { Routes } from '~/utils/routing/routes'

  definePageMeta({
    middleware: 'auth',
    layout: false
  })

  const { $loadBeneficiaryWithHistory } = useNuxtApp()
  const route = useRoute()
  const isMinistryAgent = useMinistryAgent()

  const {
    data: beneficiary,
    pending,
    error
  } = useLazyAsyncData(getRandomId('beneficiary'), loadBeneficiary, {
    server: false
  })

  const backLink = computed(() => Routes.Beneficiary(route.params.id))

  const referents = computed(() =>
    beneficiary.value.referents
      .map(({ referent }) => agentName(referent))
      .join(', ')
  )

  const {
    usualName,
    minorChildrenLabel,
    majorChildrenLabel,
    hasAddress,
    hasHealthSection,
    hasOccupationIncomeSection,
    hasOtherInformationSection,
    legalFollowUpTypes,
    optionalFollowUpTypes,
    mainIncomeType,
    partnerMainIncomeType,
    majorChildrenMainIncomeType,
    pensionOrganisations,
    hasNirAccess,
    phone
  } = useBeneficiaryDetails(beneficiary)

  watch(
    () => beneficiary.value && !pending.value,
    async fullyLoaded => {
      if (!fullyLoaded) return
      await nextTick()
      window.print()
    }
  )

  async function loadBeneficiary() {
    return await $loadBeneficiaryWithHistory(route.params.id)
  }
</script>

<style lang="scss">
  .beneficiary-details-section {
    --title-spacing: 0 0 0.75rem;

    &:not(:last-child) {
      margin-bottom: 2rem;
    }
  }
</style>
